package org.apache.bcel.verifier.statics;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.Hashtable;
import org.apache.bcel.generic.Type;
import org.apache.bcel.verifier.exc.LocalVariableInfoInconsistentException;

public class LocalVariableInfo {
  private final Hashtable<String, Type> types = new Hashtable<>();
  
  private final Hashtable<String, String> names = new Hashtable<>();
  
  private void add(int offset, String name, Type t) throws LocalVariableInfoInconsistentException {
    if (getName(offset) != null && !getName(offset).equals(name))
      throw new LocalVariableInfoInconsistentException("At bytecode offset '" + offset + "' a local variable has two different names: '" + 
          getName(offset) + "' and '" + name + "'."); 
    if (getType(offset) != null && !getType(offset).equals(t))
      throw new LocalVariableInfoInconsistentException("At bytecode offset '" + offset + "' a local variable has two different types: '" + 
          getType(offset) + "' and '" + t + "'."); 
    setName(offset, name);
    setType(offset, t);
  }
  
  public void add(String name, int startPc, int length, Type type) throws LocalVariableInfoInconsistentException {
    for (int i = startPc; i <= startPc + length; i++)
      add(i, name, type); 
  }
  
  public String getName(int offset) {
    return this.names.get(Integer.toString(offset));
  }
  
  public Type getType(int offset) {
    return this.types.get(Integer.toString(offset));
  }
  
  private void setName(int offset, String name) {
    this.names.put(Integer.toString(offset), name);
  }
  
  private void setType(int offset, Type t) {
    this.types.put(Integer.toString(offset), t);
  }
}
